"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTheme = exports.ThemeProvider = void 0;
const react_1 = __importStar(require("react"));
const ramda_1 = require("ramda");
const react_2 = require("@emotion/react");
const tiny_invariant_1 = __importDefault(require("tiny-invariant"));
const ThemeContext = (0, react_1.createContext)({
    theme: {},
    setTheme: () => { },
    updateTheme: () => { },
});
const ThemeProvider = ({ theme: initialTheme, children, }) => {
    const [theme, setTheme] = (0, react_1.useState)(initialTheme);
    const updateTheme = (modifiedTheme) => {
        if (!theme)
            return;
        const value = (0, ramda_1.mergeDeepRight)(theme !== null && theme !== void 0 ? theme : {}, modifiedTheme);
        setTheme(value);
    };
    return (react_1.default.createElement(ThemeContext.Provider, { value: {
            theme,
            setTheme,
            updateTheme,
        } },
        react_1.default.createElement(react_2.ThemeProvider, { theme: theme !== null && theme !== void 0 ? theme : {} }, children)));
};
exports.ThemeProvider = ThemeProvider;
const useTheme = () => {
    const context = (0, react_1.useContext)(ThemeContext);
    (0, tiny_invariant_1.default)(context, 'useTheme must be used within a ThemeProvider');
    return context;
};
exports.useTheme = useTheme;
