"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildColorTheme = void 0;
const values_js_1 = __importDefault(require("values.js"));
const buildColorTheme = (COLORS) => ({
    palette: {
        primary: {
            main: COLORS.primary,
            light: new values_js_1.default(COLORS.primary).tint(90).rgbString(),
            dark: new values_js_1.default(COLORS.primary).shade(40).rgbString(),
        },
        secondary: {
            main: COLORS.secondary,
            light: new values_js_1.default(COLORS.secondary).tint(90).rgbString(),
            dark: new values_js_1.default(COLORS.secondary).shade(40).rgbString(),
        },
        positive: {
            main: COLORS.positive,
            light: new values_js_1.default(COLORS.positive).tint(90).rgbString(),
            dark: new values_js_1.default(COLORS.positive).shade(40).rgbString(),
        },
        negative: {
            main: COLORS.negative,
            light: new values_js_1.default(COLORS.negative).tint(90).rgbString(),
            dark: new values_js_1.default(COLORS.negative).shade(40).rgbString(),
        },
        highlight: {
            main: COLORS.highlight,
            light: new values_js_1.default(COLORS.highlight).tint(90).rgbString(),
            dark: new values_js_1.default(COLORS.highlight).shade(40).rgbString(),
        },
        background: {
            main: COLORS.base,
            dark: new values_js_1.default(COLORS.base).shade(30).rgbString(),
        },
        text: {
            main: COLORS.text,
            light: new values_js_1.default(COLORS.text).tint(40).rgbString(),
        },
        disabled: new values_js_1.default(COLORS.base).shade(20).rgbString(),
    },
});
exports.buildColorTheme = buildColorTheme;
