"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useMediaQuery = exports.MediaQueryProvider = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Theme_1 = require("@procyon/styles/Theme");
const MediaQueryContext = (0, react_1.createContext)({
    mq: 'xl',
    setMq: () => { },
});
const MediaQueryProvider = ({ children }) => {
    const [mq, setMq] = (0, react_1.useState)('xl');
    const { theme } = (0, Theme_1.useTheme)();
    const brs = theme.breakpoints;
    const brKeys = Object.keys(brs);
    const handleChange = () => {
        Object.entries(brs).some(([key, value], index) => {
            const next = brKeys[index + 1];
            const nextBr = brs[next];
            if (isInRange(value, nextBr)) {
                setMq(key);
                return true;
            }
        });
    };
    (0, react_1.useEffect)(() => {
        handleChange();
        const sub = react_native_1.Dimensions.addEventListener('change', handleChange);
        return () => {
            sub.remove();
        };
    }, []);
    return (react_1.default.createElement(MediaQueryContext.Provider, { value: { mq, setMq } }, children));
};
exports.MediaQueryProvider = MediaQueryProvider;
const useMediaQuery = () => {
    const context = (0, react_1.useContext)(MediaQueryContext);
    if (!context) {
        throw new Error('useMediaQuery must be used within a MediaQueryProvider');
    }
    return context.mq;
};
exports.useMediaQuery = useMediaQuery;
const isInRange = (br, nextBr) => {
    const windowWidth = react_native_1.Dimensions.get('window').width;
    return br <= windowWidth && (nextBr >= windowWidth || br === nextBr);
};
